;                           
;
; 	* Query(anti)Flood 0.5 *
; 
; Author:
;	Zyberdog <zyberdog@quakenet.org>
;
; Description:
;	Simplistic query-blocking addon which allows X amount of queries within X time. Flood will then be ignore for X minutes.
;	Optional logging.
;
; Instructions:
;	To load this addon simply unzip it to somewhere preferably in your mirc dir / subfolder and type: /load -rs path\to\query(anti)flood.mrc
;	If you want to unload it either use the unload option in menubar entry, or type: /unload -rs path\to\query(anti)flood.mrc
;
; Changelog:
;   v0.5 (23/12/2003)
;	+ Added ignore mask choosing.
;   v0.4 (23/12/2003)
;	- First public release.
;
;                          

on *:LOAD:{
  if ($version >= 6.1) {
    e -
    e You've successfully loaded the query(anti)flood addon.
    e This addon is by default turned on, you can change this through the menubar > query (anti) flood
    e When turned on you will find additional nicklist/query menus to toggle specific hosts to be allowed (overrides flood).
    e By default it allowes 3 queries per 10 seconds and ignores for 10mins, these values are changeable through the menubar entry aswell.
    e -
    set %query.flood.ignore 600
    set %query.flood.num 3
    set %query.flood.time 10
    set %query.flood.type 3
    set %query.flood.log on
  }
  else {
    e -
    e Your mIRC version is outdated and are not guarantied to work with this version. Have only been tested with mIRC v6.1+
    e This means there will be no support if this addon disappoints you, or fails in any way.
    e If you do not want to take this risk please unload now using: /unload -rs $script
    e -
  }
}

menu menubar {
  query (anti) flood
  .setup dialog:qaf
  .-
  .view log:window -az @QueryFloodLog | if ($lines($scriptdirlog.txt) => 1) { .loadbuf -r @QueryFloodLog $+(",$scriptdirlog.txt,") } | else { aline @QueryFloodLog The logfile is empty. }
  .about:e Query(anti)Flood v0.5 by Zyberdog <zyberdog@quakenet.org> | e Specs: allows %query.flood.num queries within %query.flood.time second(s), the rest are ignored (for $int($calc(%query.flood.ignore /60)) $+ mins) and info echo'd to active window (+ log if turned on).
  .unload: if ($?!="Are you sure you want to unload this addon?") { e Unloading addon, removing all varialbles and userlist addings used by this addon... | .rlevel allowquery | unset %query.flood* | .unload $script }
}

menu @QueryFloodLog {
  refresh:if ($lines($scriptdirlog.txt) >= 1) { .loadbuf -r @QueryFloodLog $+(",$scriptdirlog.txt,") } | else { clear $active | aline @QueryFloodLog The logfile is empty. }
  clear logfile:write -c $+(",$scriptdirlog.txt,") | close -@ $active
  close:window -c $active
}

dialog query.anti.flood {
  title "query(anti)flood [/qaf]"
  size -1 -1 177 110
  option dbu
  button "done", 1, 137 96 37 12, ok
  check "enable/disable addon", 2, 6 12 66 10
  box "[ log ]", 3, 2 62 100 4
  check "enable/disable logging", 4, 6 70 68 10
  text "log contain X entries", 5, 6 81 94 8
  box "[ values ]", 6, 2 23 100 4
  box "[ default ignore mask ]", 7, 106 4 68 4
  text "queries allowed:", 8, 6 31 69 8
  text "timeframe to allow in (secs):", 9, 6 42 69 8
  text "minutes to ignore flooders:", 10, 6 53 69 8
  box "", 11, 2 89 172 4
  edit "1", 12, 76 30 20 10, right
  edit "2", 13, 76 40 20 10, right
  edit "3", 14, 76 51 20 10, right
  box "", 15, 106 8 1 81
  box "[ setup ]", 16, 2 4 104 4
  radio "*!user@host", 17, 112 14 60 8
  radio "*!*user@host", 18, 112 21 60 8
  radio "*!*user@*.host", 19, 112 35 60 8
  radio "*!*@host", 20, 112 28 60 8
  radio "nick!*@host", 21, 112 63 60 8
  radio "nick!*user@host", 22, 112 56 60 8
  radio "nick!user@host", 23, 112 49 60 8
  radio "*!*@*.host", 24, 112 42 60 8
  radio "nick!*user@*.host", 25, 112 71 60 8
  radio "nick!*@*.host", 26, 112 79 60 8
  text "v0.5", 27, 5 98 25 8
}

on *:dialog:query.anti.flood:*:*:{
  if ($devent == init) {
    did -ra $dname 5 log contain $iif($lines($scriptdirlog.txt),$ifmatch,0) entries
    if ($group(#queryantiflood) == on) { did -c $dname 2 }
    if (%query.flood.log == on) { did -c $dname 4 }
    did -ra $dname 12 %query.flood.num
    did -ra $dname 13 %query.flood.time
    did -ra $dname 14 $int($calc(%query.flood.ignore /60))
    did -c $dname $calc(%query.flood.type +17)
  }
  elseif ($devent == sclick) {
    if ($did == 2) { if ($did($dname,2).state == 1) { .enable #queryantiflood } | else { .disable #queryantiflood } }
    elseif ($did == 4) { if ($did($dname,4).state == 1) { set %query.flood.log on } | else { set %query.flood.log off } }
    elseif ($did == 1) { if ($+(%query.flood.time,%query.flood.ignore,%query.flood.num) !isnum) { var %a = $input(All values needs to be numeric,o,Error) | .timer -m 1 10 qas | .timer -m 1 100 did -r query.anti.flood 12,13,14 } }
    elseif ($did isnum 17-26) { set %query.flood.type $calc($did -17) }
  }
  elseif ($devent = edit) {
    if ($did == 12) { set %query.flood.num $did($dname,12).text }
    elseif ($did == 13) { set %query.flood.time $did($dname,13).text }
    elseif ($did == 14) { set %query.flood.ignore $calc($did($dname,14).text *60) }
  }
}
alias qaf { dialog -m query.anti.flood query.anti.flood }
alias -l e { echo -at $iif($1 != -,[QueryFlood] $1-,$str(-,50)) }

#queryantiflood off
on ^*:OPEN:?:{
  if ($ulevel == allowquery) { return }
  if (%query.flood >= %query.flood.num) && (? !iswm $nick) {
    haltdef
    .ignore $+(-pntidu,%query.flood.ignore) $nick %query.flood.type
    close -m $nick
    if (%query.flood.log == on) { write $+(",$scriptdirlog.txt,") [[ $fulldate ]] " $+ $nick $+ " ( $+ $address $+ ): $strip($1-) }
    e " $+ $nick $+ " ( $+ $address $+ ): $strip($1-)
    halt
  }
  else {
    inc $+(-u,%query.flood.time) %query.flood
  }
}

menu query,nicklist {
  $iif($$1,QueryFlood [[ $+ $iif($len($$1) > 5,$left($$1,5) $+ ...,$$1) $+ ]])
  .$style(2) [[ Toggle hostmasks ]]:return
  .-
  .$iif($level($mask($ial($$1),0)) == allowquery,$style(1)) $mask($ial($$1),0) :if ($level($mask($ial($$1),0)) == allowquery) { ruser allowquery $$1 0 } | else { guser allowquery $$1 0 }
  .$iif($level($mask($ial($$1),1)) == allowquery,$style(1)) $mask($ial($$1),1) :if ($level($mask($ial($$1),1)) == allowquery) { ruser allowquery $$1 1 } | else { guser allowquery $$1 1 }
  .$iif($level($mask($ial($$1),2)) == allowquery,$style(1)) $mask($ial($$1),2) :if ($level($mask($ial($$1),2)) == allowquery) { ruser allowquery $$1 2 } | else { guser allowquery $$1 2 }
  .$iif($level($mask($ial($$1),3)) == allowquery,$style(1)) $mask($ial($$1),3) :if ($level($mask($ial($$1),3)) == allowquery) { ruser allowquery $$1 3 } | else { guser allowquery $$1 3 }
  .$iif($level($mask($ial($$1),4)) == allowquery,$style(1)) $mask($ial($$1),4) :if ($level($mask($ial($$1),4)) == allowquery) { ruser allowquery $$1 4 } | else { guser allowquery $$1 4 }
  .$iif($level($mask($ial($$1),5)) == allowquery,$style(1)) $mask($ial($$1),5) :if ($level($mask($ial($$1),5)) == allowquery) { ruser allowquery $$1 5 } | else { guser allowquery $$1 5 }
  .$iif($level($mask($ial($$1),6)) == allowquery,$style(1)) $mask($ial($$1),6) :if ($level($mask($ial($$1),6)) == allowquery) { ruser allowquery $$1 6 } | else { guser allowquery $$1 6 }
  .$iif($level($mask($ial($$1),7)) == allowquery,$style(1)) $mask($ial($$1),7) :if ($level($mask($ial($$1),7)) == allowquery) { ruser allowquery $$1 7 } | else { guser allowquery $$1 7 }
  .$iif($level($mask($ial($$1),8)) == allowquery,$style(1)) $mask($ial($$1),8) :if ($level($mask($ial($$1),8)) == allowquery) { ruser allowquery $$1 8 } | else { guser allowquery $$1 8 }
  .$iif($level($mask($ial($$1),9)) == allowquery,$style(1)) $mask($ial($$1),9) :if ($level($mask($ial($$1),9)) == allowquery) { ruser allowquery $$1 9 } | else { guser allowquery $$1 9 }
}
#queryantiflood end

;              
;      E O F      
;              
